%global forgeurl https://github.com/ytdl-org/youtube-dl/
%global commit c5098961b04ce83f4615f2a846c84f803b072639
%global shortcommit %(echo %{commit} | cut -c1-7)
Name:           youtube-dl
Version:        2024.08.06.git%{shortcommit}
Release:        1%{?dist}
Summary:        A small command-line program to download online videos
License:        Unlicense
URL:            %{forgeurl}
Source:         %{forgeurl}/archive/%{commit}/youtube-dl-%{commit}.tar.gz
Source3:        %{name}.conf
# https://github.com/ytdl-org/youtube-dl/pull/32188
Patch0001:      https://github.com/ytdl-org/youtube-dl/pull/32188.patch#./manpage-formatting.patch
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-setuptools
Requires:       python%{python3_pkgversion}-setuptools
BuildArch:      noarch
BuildRequires:  pandoc
BuildRequires:  make
Recommends:     AtomicParsley
Recommends:     /usr/bin/ffmpeg


%description
Small command-line program to download videos from YouTube and other sites.


%prep
%forgesetup

cp -a setup.py setup.py.installpath
sed -i '/youtube-dl.bash-completion/d' setup.py
sed -i '/youtube-dl.fish/d' setup.py
sed -i '/README.txt/d' setup.py

find youtube_dl -type f -exec sed -i -e '1{/^\#!\/usr\/bin\/env python$/d;};' {} +

%build
%py3_build
make PYTHON=python3



%install
%py3_install

install -Dpm644 %{S:3} -t %{buildroot}%{_sysconfdir}
install -Dpm644 youtube-dl.bash-completion %{buildroot}%{_datadir}/bash-completion/completions/youtube-dl
install -Dpm644 youtube-dl.zsh %{buildroot}%{_datadir}/zsh/site-functions/_youtube-dl
install -Dpm644 youtube-dl.fish %{buildroot}%{_datadir}/fish/vendor_functions.d/youtube-dl.fish

%check


%files
%doc AUTHORS ChangeLog README.md
%{python3_sitelib}/youtube_dl/
%{python3_sitelib}/youtube_dl*.egg-info
%license LICENSE
%{_bindir}/%{name}
%{_mandir}/man1/%{name}.1*
%config(noreplace) %{_sysconfdir}/%{name}.conf
%{_datadir}/bash-completion/completions/%{name}
%dir %{_datadir}/zsh
%dir %{_datadir}/zsh/site-functions
%{_datadir}/zsh/site-functions/_youtube-dl
%dir %{_datadir}/fish
%dir %{_datadir}/fish/vendor_functions.d
%{_datadir}/fish/vendor_functions.d/youtube-dl.fish

%changelog
* Thu Feb 27 2025 Doris Chao <doriscchao@tencent.com> - 2024.08.06.gitc509896-1
- [Type] security
- [DESC] update to version 2024.08.06.gitc509896-1 to fix CVE-2024-38519.

* Tue Sep 10 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2023.08.04.git86e3cf5-1
- initial build
